


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <errno.h>
#include "mgu.h"

int setupgpios()
{
	// LS165 clock
	writegpiofile("/sys/class/gpio/export", "5");
	setgpiovalue(5, 0); 
	writegpiofile("/sys/class/gpio/gpio5/direction", "out");


	//  LS165 data out
	writegpiofile("/sys/class/gpio/export", "6");
	writegpiofile("/sys/class/gpio/gpio6/direction", "in");

	//  LS165 latch enable (H-L-H)
	writegpiofile("/sys/class/gpio/export", "12");
	setgpiovalue(12, 1); 
	writegpiofile("/sys/class/gpio/gpio12/direction", "out");

	//  4094 data
	writegpiofile("/sys/class/gpio/export", "13");
	writegpiofile("/sys/class/gpio/gpio13/direction", "out");

	//  4094 clock (L-H)
	writegpiofile("/sys/class/gpio/export", "19");
	setgpiovalue(19, 0);
	writegpiofile("/sys/class/gpio/gpio19/direction", "out");

	//  4094 LE, outbound Data ready set (L-H-L)
	writegpiofile("/sys/class/gpio/export", "16");
	setgpiovalue(16, 0); 
	writegpiofile("/sys/class/gpio/gpio16/direction", "out");

	//  outbound data ready bit
	writegpiofile("/sys/class/gpio/export", "26");
	writegpiofile("/sys/class/gpio/gpio26/direction", "in");

	//  Request clear (L)
	writegpiofile("/sys/class/gpio/export", "20");
	setgpiovalue(20, 1); 
	writegpiofile("/sys/class/gpio/gpio20/direction", "out");
	setgpiovalue(20, 1); 

	// Request status
	writegpiofile("/sys/class/gpio/export", "21");
	writegpiofile("/sys/class/gpio/gpio21/direction", "in");

	// 8085 Reset. Usually H, pulse H-L-H to reset the 8085 
	writegpiofile("/sys/class/gpio/export", "23");
	setgpiovalue(23, 1); 
	writegpiofile("/sys/class/gpio/gpio23/direction", "out");

	// GPIO25, mode in, maps to port 0x0 bit 2 also.  Pulled H with
	// a resistor. Alternate mode is L
	writegpiofile("/sys/class/gpio/export", "25");
	setgpiovalue(25, 1); 
	writegpiofile("/sys/class/gpio/gpio25/direction", "out");

	return(0);
}





